/*
 * Prey Server Launcher
 * @author Martin "DI-MeisterM" Mller
 * Source Code Date: 18/07/2006
 * 
 * cvars.java
 * This file defines all cvars of Prey which are used in the launcher
 * and writes them to the console / cfg file.
 */

import java.io.*;


public class cvars 
{
	/*
	 * Default Prey CVARS
	 * Others can be added very easily here.
	 */
	public static String MAP = "seta si_map game/"; 
	public static String NET_MASTER = "seta net_master0 preymaster.humanhead.com:27655"; 
	public static String MAXPLAYERS = "seta si_maxPlayers 8"; 
	public static String ALLOWCHEATS = "seta net_allowCheats 0";
	public static String SERVERTYPE = "seta net_LANServer 0"; 
	public static String REMOTECONSOLEPASS = "seta net_serverRemoteConsolePassword "; 
	public static String SPECTATORS = "seta si_spectators 1"; 
	public static String SERVERPASS = "seta si_usePass 0";
	public static String WARMUP = "seta si_warmup 1"; 
	public static String TEAMDAMAGE = "seta si_teamDamage 0";
	public static String TIMELIMIT = "seta si_timeLimit 10";
	public static String FRAGLIMIT = "seta si_fragLimit 10";
	public static String GAMETYPE = "seta si_gameType Deathmatch"; 
	public static String HOSTNAME = "seta si_name Prey Server"; 
	public static String PUNKBUSTER = "seta sv_punkbuster 0"; 
	public static String GPASSWORD ="seta g_password ";
	public static String SERVERRATE ="seta gui_configServerRate ";
	public static String SERVERPORT ="+set net_port ";
	
	/*
	 * Methods for resetting the CVARS
	 * Needed for user changes to the GUI
	 */
	private void reset_NET_MASTER() { NET_MASTER = "seta net_master0 preymaster.humanhead.com:27655"; }
	private void reset_MAXPLAYERS() { MAXPLAYERS = "seta si_maxPlayers "; }
	private void reset_ALLOWCHEATS() { ALLOWCHEATS = "seta net_allowCheats "; }
	private void reset_SERVERTYPE() { SERVERTYPE = "seta net_LANServer "; }
	private void reset_REMOTECONSOLEPASS() { REMOTECONSOLEPASS = "seta net_serverRemoteConsolePassword "; }
	private void reset_SPECTATORS() { SPECTATORS = "seta si_spectators "; }
	private void reset_SERVERPASS() { SERVERPASS = "seta si_usePass "; }
	private void reset_WARMUP() { WARMUP = "seta si_warmup "; }
	private void reset_TEAMDAMAGE() { TEAMDAMAGE = "seta si_teamDamage "; }
	private void reset_TIMELIMIT() { TIMELIMIT = "seta si_timeLimit "; }
	private void reset_FRAGLIMIT() { FRAGLIMIT = "seta si_fragLimit "; }
	private void reset_GAMETYPE() { GAMETYPE = "seta si_gameType "; }
	private void reset_HOSTNAME() { HOSTNAME = "seta si_name "; }
	private void reset_PUNKBUSTER() { PUNKBUSTER = "seta sv_punkbuster "; }
	private void reset_GPASSWORD() { GPASSWORD = "seta g_password "; }
	private void reset_SERVERRATE() { SERVERRATE = "seta gui_configServerRate "; }
	public void reset_SERVERPORT() { SERVERPORT ="+set net_port "; }
	
	/*
	 * Resetting all CVARS which are necessary, so not really every single cvar
	 * is added to this method. For example MAP and SERVERPORT aren't added.
	 */
	public void reset_all()
	{
		reset_NET_MASTER();
		reset_MAXPLAYERS();
		reset_ALLOWCHEATS();
		reset_SERVERTYPE();
		reset_SERVERTYPE();
		reset_REMOTECONSOLEPASS();
		reset_SPECTATORS();
		reset_SERVERPASS();
		reset_WARMUP();
		reset_TEAMDAMAGE();
		reset_TIMELIMIT();
		reset_FRAGLIMIT();
		reset_GAMETYPE();
		reset_HOSTNAME();
		reset_PUNKBUSTER();
		reset_GPASSWORD();
		reset_SERVERRATE();
	}
	
	/* 
	 * Writing all CVARS in Java console (for debugging) and to a cfg file
	 */
	public void print_all() throws IOException
	{
		System.out.println("******CVARS START*****");	
		System.out.println(HOSTNAME);	
		System.out.println(GAMETYPE);
		System.out.println(PUNKBUSTER);
		System.out.println(NET_MASTER);
		System.out.println(MAXPLAYERS);
		System.out.println(FRAGLIMIT);
		System.out.println(TIMELIMIT);
		System.out.println(ALLOWCHEATS);
		System.out.println(SERVERTYPE);
		System.out.println(REMOTECONSOLEPASS);
		System.out.println(SPECTATORS);
		System.out.println(SERVERPASS);
		System.out.println(GPASSWORD);
		System.out.println(WARMUP);
		System.out.println(TEAMDAMAGE);
		System.out.println(SERVERRATE);
		System.out.println(MAP);
		System.out.println("******CVARS ENDE*****");
		System.out.println(preyserverlauncher.CURRENTPORT);
		
		/*
		 * Here starts the FileWriter, which writes all CVARs to a file. The filename
		 * you can change in preylauncher.java.
		 */
		Writer output = new FileWriter(preyserverlauncher.getfilename());
		String credits = "//"+preyserverlauncher.gettitle()+preyserverlauncher.getauthor();
		output.write(credits+"\n"+HOSTNAME+"\n"+GAMETYPE+"\n"+PUNKBUSTER+"\n"+NET_MASTER+"\n"+
			MAXPLAYERS+"\n"+FRAGLIMIT+"\n"+TIMELIMIT+"\n"+ALLOWCHEATS+"\n"+SERVERTYPE+"\n"
			+REMOTECONSOLEPASS+"\n"+SPECTATORS+"\n"+SERVERPASS+"\n"+GPASSWORD+"\n"
			+WARMUP+"\n"+TEAMDAMAGE+"\n"+SERVERRATE+"\n"+MAP+"\n"+"spawnserver");
		output.close();
	}
}
