/*
 * Prey Server Launcher
 * @author Martin "DI-MeisterM" Mller
 * Source Code Date: 18/07/2006
 * 
 * preylauncher.java
 * This file is the main progam. It includes the GUI and all actionlisteners.
 */

import java.awt.*;
import javax.swing.*;
import java.lang.String;
import java.awt.Rectangle;
import javax.swing.JLabel;
import javax.swing.JTextField;
import java.awt.Choice;
import javax.swing.JButton;
import java.io.*;
import javax.swing.JTextArea;
import java.awt.Color;

public class preyserverlauncher 
{
	public static cvars cvars = new cvars();  //  //  @jve:decl-index=0:
	public static maps maps = new maps();  //  //  @jve:decl-index=0:
	
	/*
	 * Strings for filename, version, paths, author...
	 */
	private static String VERSION="1.2";  //  
	private static String AUTHOR="by Martin 'DI-MeisterM' Mller";  //  
	private static String PROGRAMTITLE="Prey Server Launcher ";
	private static String FILENAME2="preylauncher.cfg";  //  @jve:decl-index=0:
	private static String FILENAME=".\\base\\"+FILENAME2;  //  @jve:decl-index=0:
	public static String CURRENTPORT="";  //  @jve:decl-index=0:
	
	/*
	 * GUI elements
	 */
	private static JFrame jFrame = null;  //  @jve:decl-index=0:visual-constraint="26,20"
	private static JPanel jContentPane = null;
	public static JLabel preylogofeld = null;
	private static JLabel HOSTNAME_JLabel = null;
	private static JTextField HOSTNAME_TextField = null;
	private static JLabel SERVERTYPE_jLabel = null;
	private static Choice SERVERTYPE_choice = null;
	private static JLabel TEAMDAMAGE_jLabel = null;
	private static JLabel FRAGLIMIT_jLabel = null;
	private static JTextField FRAGLIMIT_jTextField = null;
	private static JLabel TIMELIMIT_jLabel = null;
	private static JTextField TIMELIMIT_jTextField = null;
	private static JLabel SPECTATORS_jLabel = null;
	private static JLabel WARMUP_jLabel = null;
	private static JLabel PUNKBUSTER_jLabel = null;
	private static Choice TEAMDAMAGE_choice = null;
	private static Choice SPECTATOR_choice = null;
	private static Choice WARMUP_choice = null;
	private static Choice PUNKBUSTER_choice = null;
	private static JLabel MAXPLAYERS_jLabel = null;
	private static JTextField MAXPLAYERS_jTextField = null;
	private static JLabel GAMETYPE_jLabel = null;
	private static Choice GAMETYPE_choice = null;
	private static JLabel MAPS_jLabel = null;
	private static Choice MAPS_choice = null;
	private static JButton SAVE_jButton = null;
	private static JLabel SERVERPASSWORD_jLabel = null;
	private static Choice SERVERPASSWORD_choice = null;
	private static JTextField SERVERPASSWORD_jTextField = null;
	private static JLabel REMOTECONSOLEPASS_jLabel = null;
	private static JTextField REMOTECONSOLPASS_jTextField = null;
	private static JLabel ALLOWCHEATS_jLabel = null;
	private static Choice ALLOWCHEATS_choice = null;
	private static JLabel SERVERRATE_jLabel = null;
	private static Choice SERVERRATE_choice = null;
	private static JLabel BANNER_jLabel = null;
	private static JButton LAUNCH_jButton = null;
	private static JTextArea MESSAGEWINDOW_jTextArea = null;
	private static JLabel SERVERPORT_jLabel = null;
	private static JTextField SERVERPORT_jTextField = null;
	
	/**
	 * This method initializes jFrame	
	 * 	
	 * @return javax.swing.JFrame	
	 */
	private static JFrame getJFrame() 
	{
		if (jFrame == null) 
		{
			jFrame = new JFrame();
			jFrame.setTitle(PROGRAMTITLE+VERSION+" "+AUTHOR);
			jFrame.setSize(new Dimension(640, 480));
			jFrame.setVisible(true);
			jFrame.setLayout(null);
			jFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
			jFrame.setContentPane(getJContentPane());
			jFrame.setResizable(false);
		}
		return jFrame;
	}

	/**
	 * This method initializes jContentPane	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private static JPanel getJContentPane() 
	{
		if (jContentPane == null) 
		{
			SERVERPORT_jLabel = new JLabel();
			SERVERPORT_jLabel.setBounds(new Rectangle(4, 365, 105, 16));
			SERVERPORT_jLabel.setText("Serverport (TCP):");
			SERVERPORT_jLabel.setForeground(Color.white);
			BANNER_jLabel = new JLabel();
			BANNER_jLabel.setIcon(new ImageIcon(".\\preylauncherimages\\general\\banner.jpg"));
			BANNER_jLabel.setBounds(new Rectangle(4, 1, 629, 62));
			BANNER_jLabel.setText("JLabel");
			SERVERRATE_jLabel = new JLabel();
			SERVERRATE_jLabel.setForeground(java.awt.Color.white);
			SERVERRATE_jLabel.setBounds(new Rectangle(330, 341, 83, 16));
			SERVERRATE_jLabel.setText("Server Rate:");
			ALLOWCHEATS_jLabel = new JLabel();
			ALLOWCHEATS_jLabel.setForeground(java.awt.Color.white);
			ALLOWCHEATS_jLabel.setBounds(new Rectangle(499, 247, 52, 16));
			ALLOWCHEATS_jLabel.setText("Cheats:");
			REMOTECONSOLEPASS_jLabel = new JLabel();
			REMOTECONSOLEPASS_jLabel.setForeground(java.awt.Color.white);
			REMOTECONSOLEPASS_jLabel.setBounds(new Rectangle(330, 312, 160, 16));
			REMOTECONSOLEPASS_jLabel.setText("Remote Console Password:");
			SERVERPASSWORD_jLabel = new JLabel();
			SERVERPASSWORD_jLabel.setForeground(java.awt.Color.white);
			SERVERPASSWORD_jLabel.setBounds(new Rectangle(330, 278, 108, 16));
			SERVERPASSWORD_jLabel.setText("Game Password:");
			MAPS_jLabel = new JLabel();
			MAPS_jLabel.setForeground(java.awt.Color.white);
			MAPS_jLabel.setBounds(new Rectangle(4, 322, 76, 16));
			MAPS_jLabel.setText("Startup Map:");
			GAMETYPE_jLabel = new JLabel();
			GAMETYPE_jLabel.setForeground(java.awt.Color.white);
			GAMETYPE_jLabel.setBounds(new Rectangle(330, 132, 73, 16));
			GAMETYPE_jLabel.setText("Game Type:");
			MAXPLAYERS_jLabel = new JLabel();
			MAXPLAYERS_jLabel.setForeground(java.awt.Color.white);
			MAXPLAYERS_jLabel.setBounds(new Rectangle(330, 248, 76, 16));
			MAXPLAYERS_jLabel.setText("Max. Players:");
			PUNKBUSTER_jLabel = new JLabel();
			PUNKBUSTER_jLabel.setForeground(java.awt.Color.white);
			PUNKBUSTER_jLabel.setBounds(new Rectangle(499, 219, 73, 16));
			PUNKBUSTER_jLabel.setText("Punkbuster:");
			WARMUP_jLabel = new JLabel();
			WARMUP_jLabel.setForeground(java.awt.Color.white);
			WARMUP_jLabel.setBounds(new Rectangle(498, 189, 61, 16));
			WARMUP_jLabel.setText("Warm up:");
			SPECTATORS_jLabel = new JLabel();
			SPECTATORS_jLabel.setForeground(java.awt.Color.white);
			SPECTATORS_jLabel.setBounds(new Rectangle(330, 219, 117, 16));
			SPECTATORS_jLabel.setText("Spectators allowed:");
			TIMELIMIT_jLabel = new JLabel();
			TIMELIMIT_jLabel.setForeground(java.awt.Color.white);
			TIMELIMIT_jLabel.setBounds(new Rectangle(498, 157, 60, 16));
			TIMELIMIT_jLabel.setText("Timelimit:");
			FRAGLIMIT_jLabel = new JLabel();
			FRAGLIMIT_jLabel.setForeground(java.awt.Color.white);
			FRAGLIMIT_jLabel.setBounds(new Rectangle(330, 157, 60, 16));
			FRAGLIMIT_jLabel.setText("Fraglimit:");
			TEAMDAMAGE_jLabel = new JLabel();
			TEAMDAMAGE_jLabel.setForeground(java.awt.Color.white);
			TEAMDAMAGE_jLabel.setBounds(new Rectangle(330, 189, 93, 16));
			TEAMDAMAGE_jLabel.setText("Team Damage:");
			SERVERTYPE_jLabel = new JLabel();
			SERVERTYPE_jLabel.setForeground(java.awt.Color.white);
			SERVERTYPE_jLabel.setBounds(new Rectangle(330, 106, 38, 16));
			SERVERTYPE_jLabel.setText("Type:");
			HOSTNAME_JLabel = new JLabel();
			HOSTNAME_JLabel.setForeground(java.awt.Color.white);
			HOSTNAME_JLabel.setBounds(new Rectangle(330, 67, 73, 16));
			HOSTNAME_JLabel.setText("Hostname:");
			preylogofeld = new JLabel();
			preylogofeld.setIcon(new ImageIcon(".\\preylauncherimages\\general\\portal.jpg"));
			preylogofeld.setBounds(new Rectangle(4, 64, 320, 248));
			preylogofeld.setText("");
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.setBackground(java.awt.Color.black);
			jContentPane.add(preylogofeld, null);
			jContentPane.add(HOSTNAME_JLabel, null);
			jContentPane.add(getHOSTNAME_TextField(), null);
			jContentPane.add(SERVERTYPE_jLabel, null);
			jContentPane.add(getSERVERTYPE_choice(), null);
			jContentPane.add(TEAMDAMAGE_jLabel, null);
			jContentPane.add(FRAGLIMIT_jLabel, null);
			jContentPane.add(getFRAGLIMIT_jTextField(), null);
			jContentPane.add(TIMELIMIT_jLabel, null);
			jContentPane.add(getTIMELIMIT_jTextField(), null);
			jContentPane.add(SPECTATORS_jLabel, null);
			jContentPane.add(WARMUP_jLabel, null);
			jContentPane.add(PUNKBUSTER_jLabel, null);
			jContentPane.add(getTEAMDAMAGE_choice(), null);
			jContentPane.add(getSPECTATOR_choice(), null);
			jContentPane.add(getWARMUP_choice(), null);
			jContentPane.add(getPUNKBUSTER_choice(), null);
			jContentPane.add(MAXPLAYERS_jLabel, null);
			jContentPane.add(getMAXPLAYERS_jTextField(), null);
			jContentPane.add(GAMETYPE_jLabel, null);
			jContentPane.add(getGAMETYPE_choice(), null);
			jContentPane.add(MAPS_jLabel, null);
			jContentPane.add(getMAPS_choice(), null);
			jContentPane.add(getSAVE_jButton(), null);
			jContentPane.add(SERVERPASSWORD_jLabel, null);
			jContentPane.add(getSERVERPASSWORD_choice(), null);
			jContentPane.add(getSERVERPASSWORD_jTextField(), null);
			jContentPane.add(REMOTECONSOLEPASS_jLabel, null);
			jContentPane.add(getREMOTECONSOLPASS_jTextField(), null);
			jContentPane.add(ALLOWCHEATS_jLabel, null);
			jContentPane.add(getALLOWCHEATS_choice(), null);
			jContentPane.add(SERVERRATE_jLabel, null);
			jContentPane.add(getSERVERRATE_choice(), null);
			jContentPane.add(BANNER_jLabel, null);
			jContentPane.add(getLAUNCH_jButton(), null);
			jContentPane.add(getMESSAGEWINDOW_jTextArea(), null);
			jContentPane.add(SERVERPORT_jLabel, null);
			jContentPane.add(getSERVERPORT_jTextField(), null);
		}
		return jContentPane;
	}

	
	/*
	 * Some get_X methods
	 */
	
	public static JLabel getpreylogofeld() 
	{
		return preylogofeld;
	}
	
	public static String getauthor()
	{
		return AUTHOR;
	}
	
	public static String gettitle()
	{
		return PROGRAMTITLE;
	}
	
	public static String getfilename()
	{
		return FILENAME;
	}
	
	/**
	 * This method initializes HOSTNAME_TextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private static JTextField getHOSTNAME_TextField() 
	{
		if (HOSTNAME_TextField == null) 
		{
			HOSTNAME_TextField = new JTextField();
			HOSTNAME_TextField.setBounds(new Rectangle(447, 65, 176, 20));
			HOSTNAME_TextField.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) 
				{
					
					System.out.println(); // TODO Auto-generated Event stub actionPerformed()
				}
			});
		}
		return HOSTNAME_TextField;
	}

	/**
	 * This method initializes SERVERTYPE_choice	
	 * 	
	 * @return java.awt.Choice	
	 */
	private static Choice getSERVERTYPE_choice() 
	{
		if (SERVERTYPE_choice == null) 
		{
			SERVERTYPE_choice = new Choice();
			SERVERTYPE_choice.add("---");
			SERVERTYPE_choice.add("Local Area Network");
			SERVERTYPE_choice.add("Internet");
			SERVERTYPE_choice.setBounds(new Rectangle(447, 103, 176, 21));
		}
		return SERVERTYPE_choice;
	}

	/**
	 * This method initializes FRAGLIMIT_jTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private static JTextField getFRAGLIMIT_jTextField() 
	{
		if (FRAGLIMIT_jTextField == null) 
		{
			FRAGLIMIT_jTextField = new JTextField();
			FRAGLIMIT_jTextField.setBounds(new Rectangle(447, 157, 46, 21));
		}
		return FRAGLIMIT_jTextField;
	}

	/**
	 * This method initializes TIMELIMIT_jTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private static JTextField getTIMELIMIT_jTextField() 
	{
		if (TIMELIMIT_jTextField == null) 
		{
			TIMELIMIT_jTextField = new JTextField();
			TIMELIMIT_jTextField.setBounds(new Rectangle(576, 157, 46, 21));
		}
		return TIMELIMIT_jTextField;
	}

	/**
	 * This method initializes TEAMDAMAGE_choice	
	 * 	
	 * @return java.awt.Choice	
	 */
	private static Choice getTEAMDAMAGE_choice() 
	{
		if (TEAMDAMAGE_choice == null) 
		{
			TEAMDAMAGE_choice = new Choice();
			TEAMDAMAGE_choice.add("---");
			TEAMDAMAGE_choice.add("yes");
			TEAMDAMAGE_choice.add("no");
			TEAMDAMAGE_choice.setBounds(new Rectangle(447, 188, 46, 21));
		}
		return TEAMDAMAGE_choice;
	}

	/**
	 * This method initializes SPECTATOR_choice	
	 * 	
	 * @return java.awt.Choice	
	 */
	private static Choice getSPECTATOR_choice() 
	{
		if (SPECTATOR_choice == null) 
		{
			SPECTATOR_choice = new Choice();
			SPECTATOR_choice.add("---");
			SPECTATOR_choice.add("yes");
			SPECTATOR_choice.add("no");
			SPECTATOR_choice.setBounds(new Rectangle(447, 217, 46, 21));
		}
		return SPECTATOR_choice;
	}

	/**
	 * This method initializes WARMUP_choice	
	 * 	
	 * @return java.awt.Choice	
	 */
	private static Choice getWARMUP_choice() 
	{
		if (WARMUP_choice == null) 
		{
			WARMUP_choice = new Choice();
			WARMUP_choice.add("---");
			WARMUP_choice.add("yes");
			WARMUP_choice.add("no");
			WARMUP_choice.setBounds(new Rectangle(576, 188, 46, 21));
		}
		return WARMUP_choice;
	}

	/**
	 * This method initializes PUNKBUSTER_choice	
	 * 	
	 * @return java.awt.Choice	
	 */
	private static Choice getPUNKBUSTER_choice() 
	{
		if (PUNKBUSTER_choice == null) 
		{
			PUNKBUSTER_choice = new Choice();
			PUNKBUSTER_choice.add("---");
			PUNKBUSTER_choice.add("yes");
			PUNKBUSTER_choice.add("no");
			PUNKBUSTER_choice.setBounds(new Rectangle(576, 217, 46, 21));
		}
		return PUNKBUSTER_choice;
	}

	/**
	 * This method initializes MAXPLAYERS_jTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private static JTextField getMAXPLAYERS_jTextField() 
	{
		if (MAXPLAYERS_jTextField == null) 
		{
			MAXPLAYERS_jTextField = new JTextField();
			MAXPLAYERS_jTextField.setBounds(new Rectangle(447, 246, 46, 21));
		}
		return MAXPLAYERS_jTextField;
	}

	/**
	 * This method initializes GAMETYPE_choice	
	 * 	
	 * @return java.awt.Choice	
	 */
	private static Choice getGAMETYPE_choice() 
	{
		if (GAMETYPE_choice == null) 
		{
			GAMETYPE_choice = new Choice();
			GAMETYPE_choice.add("---");
			GAMETYPE_choice.add("Deathmatch");
			GAMETYPE_choice.add("Team Deathmatch");
			GAMETYPE_choice.setBounds(new Rectangle(447, 130, 176, 21));
		}
		return GAMETYPE_choice;
	}
	
	/*
	 * This method refreshs/updates the GUI.
	 * It's necessary if you change images in the GUI on the fly.
	 */
	public static void refreshgui()
	{ 
		 getJFrame().repaint();
 		 getJContentPane().repaint();
	}
	
	/**
	 * This method initializes MAPS_choice	
	 * 	
	 * @return java.awt.Choice	
	 */
	public static Choice getMAPS_choice() 
	{
		if (MAPS_choice == null) 
		{
			MAPS_choice = new Choice();
			maps.maps_in_auswahl_einfuegen();
			maps.maps_actionlistener();
			MAPS_choice.setBounds(new Rectangle(4, 339, 177, 21));
		}
		return MAPS_choice;
	}
	
	/*
	 * This method controls each GUI field and saves the CVARS to cvars.java
	 */
	private static void cfg_schreiben()
	{
		cvars.reset_all();
		cvars.HOSTNAME=cvars.HOSTNAME+HOSTNAME_TextField.getText();
		
		if (getSERVERTYPE_choice().getSelectedItem()=="Local Area Network")
		{
			cvars.SERVERTYPE=cvars.SERVERTYPE+"1";
		}
		else
		{
			cvars.SERVERTYPE=cvars.SERVERTYPE+"0";
		}
		
		if (getGAMETYPE_choice().getSelectedItem()=="Deathmatch")
		{
			cvars.GAMETYPE=cvars.GAMETYPE+"Deathmatch";
		}
		else
		{
			cvars.GAMETYPE=cvars.GAMETYPE+"Team DM";
		}

		cvars.FRAGLIMIT=cvars.FRAGLIMIT+FRAGLIMIT_jTextField.getText();
		cvars.TIMELIMIT=cvars.TIMELIMIT+TIMELIMIT_jTextField.getText();
		
		if (getTEAMDAMAGE_choice().getSelectedItem()=="yes")
		{
			cvars.TEAMDAMAGE=cvars.TEAMDAMAGE+"1";
		}
		else
		{
			cvars.TEAMDAMAGE=cvars.TEAMDAMAGE+"0";
		}
		
		if (getWARMUP_choice().getSelectedItem()=="yes")
		{
			cvars.WARMUP=cvars.WARMUP+"1";
		}
		else
		{
			cvars.WARMUP=cvars.WARMUP+"0";
		}
		
		if (getSPECTATOR_choice().getSelectedItem()=="yes")
		{
			cvars.SPECTATORS=cvars.SPECTATORS+"1";
		}
		else
		{
			cvars.SPECTATORS=cvars.SPECTATORS+"0";
		}
		
		if (getPUNKBUSTER_choice().getSelectedItem()=="yes")
		{
			cvars.PUNKBUSTER=cvars.PUNKBUSTER+"1";
		}
		else
		{
			cvars.PUNKBUSTER=cvars.PUNKBUSTER+"0";
		}
		cvars.MAXPLAYERS=cvars.MAXPLAYERS+MAXPLAYERS_jTextField.getText();
		if (getALLOWCHEATS_choice().getSelectedItem()=="yes")
		{
			cvars.ALLOWCHEATS=cvars.ALLOWCHEATS+"1";
		}
		else
		{
			cvars.ALLOWCHEATS=cvars.ALLOWCHEATS+"0";
		}
		if (getSERVERPASSWORD_choice().getSelectedItem()=="yes")
		{
			cvars.SERVERPASS=cvars.SERVERPASS+"1";
			cvars.GPASSWORD=cvars.GPASSWORD+SERVERPASSWORD_jTextField.getText();
		}
		else
		{
			cvars.SERVERPASS=cvars.SERVERPASS+"0";
			cvars.GPASSWORD=cvars.GPASSWORD+"";
		}
		cvars.REMOTECONSOLEPASS=cvars.REMOTECONSOLEPASS+REMOTECONSOLPASS_jTextField.getText();
			
		if (getSERVERRATE_choice().getSelectedItem()=="128 Kbit")
		{
			cvars.SERVERRATE=cvars.SERVERRATE+"0";
		}
		if (getSERVERRATE_choice().getSelectedItem()=="256 Kbit")
		{
			cvars.SERVERRATE=cvars.SERVERRATE+"1";
		}
		if (getSERVERRATE_choice().getSelectedItem()=="384 Kbit")
		{
			cvars.SERVERRATE=cvars.SERVERRATE+"2";
		}
		if (getSERVERRATE_choice().getSelectedItem()=="512 Kbit")
		{
			cvars.SERVERRATE=cvars.SERVERRATE+"3";
		}
		if (getSERVERRATE_choice().getSelectedItem()=="768 Kbit")
		{
			cvars.SERVERRATE=cvars.SERVERRATE+"4";
		}
		if (getSERVERRATE_choice().getSelectedItem()=="LAN")
		{
			cvars.SERVERRATE=cvars.SERVERRATE+"5";
		}
			cvars.reset_SERVERPORT();
			CURRENTPORT=cvars.SERVERPORT=cvars.SERVERPORT+getSERVERPORT_jTextField().getText();
		try
		{
			cvars.print_all();
		} catch (IOException e) {System.out.println("Fehler!");}
		
	}
	/**
	 * This method initializes SAVE_jButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private static JButton getSAVE_jButton() 
	{
		if (SAVE_jButton == null) 
		{
			SAVE_jButton = new JButton();
			SAVE_jButton.setBounds(new Rectangle(330, 369, 136, 35));
			SAVE_jButton.setText("Save Config");
			SAVE_jButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) 
				{
					/*
					 * This part here is a bit doggy, but there's no other solution.
					 * It makes sure that every choice-box of the GUI has chosen 
					 * a "yes" or "no". 
					 */
					if(getSERVERTYPE_choice().getSelectedItem()!="---")
					{
						if(getGAMETYPE_choice().getSelectedItem()!="---")
						{
							if(getTEAMDAMAGE_choice().getSelectedItem()!="---")
							{
								if(getWARMUP_choice().getSelectedItem()!="---")
								{
									if(getSPECTATOR_choice().getSelectedItem()!="---")
									{
										if(getPUNKBUSTER_choice().getSelectedItem()!="---")
										{
											if(getALLOWCHEATS_choice().getSelectedItem()!="---")
											{
												if(getALLOWCHEATS_choice().getSelectedItem()!="---")
												{
													if(getSERVERPASSWORD_choice().getSelectedItem()!="---")
													{
														if(getSERVERRATE_choice().getSelectedItem()!="---")
														{
															if(getMAPS_choice().getSelectedItem()!="---")
															{
																	cfg_schreiben();
																	getMESSAGEWINDOW_jTextArea().setEnabled(true);
																	getMESSAGEWINDOW_jTextArea().setForeground(java.awt.Color.red);
																	getMESSAGEWINDOW_jTextArea().setText("Config file successfully saved!");
																	getMESSAGEWINDOW_jTextArea().setEnabled(false);
																	LAUNCH_jButton.setEnabled(true);
																	System.out.println("CFG gesaved!"); // TODO Auto-generated Event stub actionPerformed()
																	System.out.println("****************************");
																	getSAVE_jButton().setEnabled(false);
															}
															else
															{
																notsaved();
															}
														}
														else
														{
															notsaved();
														}
													}
													else
													{
														notsaved();
													}
												}
												else
												{
													notsaved();
												}
											}
											else
											{
												notsaved();
											}
										}
										else
										{
											notsaved();
										}
									}
									else
									{
										notsaved();
									}
								}
								else
								{
									notsaved();
								}
							}
							else
							{
								notsaved();
							}
						}
						else
						{
							notsaved();
						}
					}
					else
					{
						notsaved();
					}
				}
			});
		}
		return SAVE_jButton;
	}
    
	/*
	 * If wrong options are chosen this method will give you the feedback.
	 */
	private static void notsaved()
	{
		getMESSAGEWINDOW_jTextArea().setEnabled(true);
		getMESSAGEWINDOW_jTextArea().setForeground(java.awt.Color.red);
		getMESSAGEWINDOW_jTextArea().setText("Config file NOT saved! Please choose for each "+"\n"+"field an option first!");
		getMESSAGEWINDOW_jTextArea().setEnabled(false);
	}
	/**
	 * This method initializes SERVERPASSWORD_choice	
	 * 	
	 * @return java.awt.Choice	
	 */
	private static Choice getSERVERPASSWORD_choice() 
	{
		if (SERVERPASSWORD_choice == null) 
		{
			SERVERPASSWORD_choice = new Choice();
			SERVERPASSWORD_choice.add("---");
			SERVERPASSWORD_choice.add("no");
			SERVERPASSWORD_choice.add("yes");
			SERVERPASSWORD_choice.setBounds(new Rectangle(447, 276, 46, 21));
			SERVERPASSWORD_choice.addItemListener(new java.awt.event.ItemListener() {
				public void itemStateChanged(java.awt.event.ItemEvent e) {
					if (getSERVERPASSWORD_choice().getSelectedItem()=="yes")
					{
						SERVERPASSWORD_jTextField.setEditable(true);
					}
					else
					{
						SERVERPASSWORD_jTextField.setEditable(false);
					}
					//System.out.println("itemStateChanged()"); // TODO Auto-generated Event stub itemStateChanged()
				}
			});
		}
		return SERVERPASSWORD_choice;
	}

	/**
	 * This method initializes SERVERPASSWORD_jTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private static JTextField getSERVERPASSWORD_jTextField() 
	{
		if (SERVERPASSWORD_jTextField == null) 
		{
			SERVERPASSWORD_jTextField = new JTextField();
			SERVERPASSWORD_jTextField.setEditable(false);
			SERVERPASSWORD_jTextField.setBounds(new Rectangle(500, 276, 121, 21));
			SERVERPASSWORD_jTextField
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							
							System.out.println("actionPerformed()"); // TODO Auto-generated Event stub actionPerformed()
						}
					});
		}
		return SERVERPASSWORD_jTextField;
	}

	/**
	 * This method initializes REMOTECONSOLPASS_jTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private static JTextField getREMOTECONSOLPASS_jTextField() 
	{
		if (REMOTECONSOLPASS_jTextField == null) {
			REMOTECONSOLPASS_jTextField = new JTextField();
			REMOTECONSOLPASS_jTextField.setBounds(new Rectangle(500, 310, 121, 21));
		}
		return REMOTECONSOLPASS_jTextField;
	}

	/**
	 * This method initializes ALLOWCHEATS_choice	
	 * 	
	 * @return java.awt.Choice	
	 */
	private static Choice getALLOWCHEATS_choice() 
	{
		if (ALLOWCHEATS_choice == null) {
			ALLOWCHEATS_choice = new Choice();
			ALLOWCHEATS_choice.add("---");
			ALLOWCHEATS_choice.add("no");
			ALLOWCHEATS_choice.add("yes");
			ALLOWCHEATS_choice.setBounds(new Rectangle(576, 246, 46, 21));
		}
		return ALLOWCHEATS_choice;
	}

	/**
	 * This method initializes SERVERRATE_choice	
	 * 	
	 * @return java.awt.Choice	
	 */
	private static Choice getSERVERRATE_choice() 
	{
		if (SERVERRATE_choice == null) 
		{
			SERVERRATE_choice = new Choice();
			SERVERRATE_choice.add("---");
			SERVERRATE_choice.add("128 Kbit");
			SERVERRATE_choice.add("256 Kbit");
			SERVERRATE_choice.add("384 Kbit");
			SERVERRATE_choice.add("512 Kbit");
			SERVERRATE_choice.add("768 Kbit");
			SERVERRATE_choice.add("LAN");
			SERVERRATE_choice.setBounds(new Rectangle(444, 339, 176, 21));
		}
		return SERVERRATE_choice;
	}

	/**
	 * This method initializes LAUNCH_jButton	
	 * It also looks if you're using the Windows or Linux Prey files for
	 * launching the server.
	 * 	
	 * @return javax.swing.JButton	
	 */
	private static JButton getLAUNCH_jButton() 
	{
		if (LAUNCH_jButton == null) 
		{
			LAUNCH_jButton = new JButton();
			LAUNCH_jButton.setEnabled(false);
			LAUNCH_jButton.setBounds(new Rectangle(485, 369, 136, 35));
			LAUNCH_jButton.setText("Launch Server");
			LAUNCH_jButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) 
				{
					getLAUNCH_jButton().setEnabled(false);
					getSAVE_jButton().setEnabled(false);
					if (new File("preyded.x86").exists())
					{
						getMESSAGEWINDOW_jTextArea().setEnabled(true);
						getMESSAGEWINDOW_jTextArea().setForeground(java.awt.Color.red);
						getMESSAGEWINDOW_jTextArea().setText("Prey LINUX Server launched...please wait!"+"\n"+"You can close this program when your server is ready.");
						getMESSAGEWINDOW_jTextArea().setEnabled(false);
						try
						{
							// Linux OS
							Runtime.getRuntime().exec("./preyded " +CURRENTPORT+" "+"+exec "+FILENAME2);	
							System.out.println("./preyded " +CURRENTPORT+" "+"+exec "+FILENAME2);
						}
						catch (Exception exp){exp.printStackTrace();};
					}
					else
					{
						if (!(new File("preyded.x86").exists()))
							{
								getMESSAGEWINDOW_jTextArea().setEnabled(true);
								getMESSAGEWINDOW_jTextArea().setForeground(java.awt.Color.red);
								getMESSAGEWINDOW_jTextArea().setText("Prey WINDOWS Server launched...please wait!"+"\n"+"You can close this program when your server is ready.");
								getMESSAGEWINDOW_jTextArea().setEnabled(false);
								try
								{
									// Windows OS
									Runtime.getRuntime().exec("PREYDed.exe "+CURRENTPORT+" "+"+exec "+FILENAME2);
									System.out.println("PREYDed.exe "+CURRENTPORT+" "+"+exec "+FILENAME2);
								}
								catch (Exception exp){exp.printStackTrace();};
							}
						else
						{
							getMESSAGEWINDOW_jTextArea().setEnabled(true);
							getMESSAGEWINDOW_jTextArea().setForeground(java.awt.Color.red);
							getMESSAGEWINDOW_jTextArea().setText("File 'PREYDed.exe' or 'preyded.x86' not found!"+"\n"+"No Prey Dedicated Server launched!");
							getMESSAGEWINDOW_jTextArea().setEnabled(false);
						}
						
					}
					System.out.println("actionPerformed()"); // TODO Auto-generated Event stub actionPerformed()
				}
			});
		}
		return LAUNCH_jButton;
	}

	/**
	 * This method initializes MESSAGEWINDOW_jTextArea	
	 * 	
	 * @return javax.swing.JTextArea	
	 */
	private static JTextArea getMESSAGEWINDOW_jTextArea() 
	{
		if (MESSAGEWINDOW_jTextArea == null) 
		{
			MESSAGEWINDOW_jTextArea = new JTextArea();
			MESSAGEWINDOW_jTextArea.setBackground(java.awt.Color.black);
			MESSAGEWINDOW_jTextArea.setEnabled(false);
			MESSAGEWINDOW_jTextArea.setBounds(new Rectangle(330, 413, 300, 34));
		}
		return MESSAGEWINDOW_jTextArea;
	}

	/**
	 * This method initializes SERVERPORT_jTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private static JTextField getSERVERPORT_jTextField() 
	{
		if (SERVERPORT_jTextField == null) 
		{
			SERVERPORT_jTextField = new JTextField();
			SERVERPORT_jTextField.setBounds(new Rectangle(4, 383, 176, 21));
			SERVERPORT_jTextField.setText("27666");
			SERVERPORT_jTextField.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					
					System.out.println("actionPerformed()"); // TODO Auto-generated Event stub actionPerformed()
				}
			});
		}
		return SERVERPORT_jTextField;
	}
		
		/**
	 * @param args
	 */
	public static void main(String[] args) 
	{
		preyserverlauncher gui = new preyserverlauncher();
		/*
		 * Launching the program / opening the GUI Window
		 */
		gui.getJFrame().show();
		System.out.println("kompilierung erfolgreich");
	}
}
